.586

.model flat, stdcall

option casemap:none

include z.inc

.code

start:



;_________________________________________________________________________________________



DriverEntry proc USES EBX ESI EDI, DriverObject, RegistryPath 
	LOCAL DeviceObject:DWORD
	LOCAL DeviceNameUnicode:UNICODE_STRING
	lea EDI, DeviceNameUnicode
	invoke RtlInitUnicodeString, EDI, ADDR DeviceName
	lea ECX, DeviceObject 
	mov ESI, DriverObject
	ASSUME ESI:PTR DRIVER_OBJECT
	invoke IoCreateDevice, ESI, 0, EDI, 8010h, 0, 1, ECX
	test EAX, EAX							; if EAX < 0 device failed
	jl CreateDeviceFailed
	mov EDX, DeviceObject 
	or  DWORD PTR [EDX + 1Eh], 0					; PDEVICE_OBJECT.FLAGS or DO_BUFFERED_IO = 4 or DO_DIRECT_IO = 10h
	mov DWORD PTR [ESI + 34h], OFFSET DriverUnload		; PDRIVER_UNLOAD
	mov DWORD PTR [ESI + 38h], OFFSET StandardDispatch	; PDISPATCH_IRP_MJ_CREATE
	mov DWORD PTR [ESI + 40h], OFFSET StandardDispatch	; PDISPATCH_IRP_MJ_CLOSE
	mov DWORD PTR [ESI + 70h], OFFSET DriverDispatch	; PDISPATCH_IRP_MJ_DEVICE_CONTROL
	mov EAX, OFFSET SymbolicLinkNameUnicode
	push EDI 
	push EAX 
	invoke RtlInitUnicodeString, EAX, ADDR DosDeviceName
	call IoCreateSymbolicLink
	test EAX, EAX 
	jge SymbolicLinkCreated
	push EAX
	invoke IoDeleteDevice, DeviceObject
	pop EAX
SymbolicLinkCreated:
CreateDeviceFailed:
	ret
DriverEntry endp 



;_________________________________________________________________________________________



StandardDispatch proc DeviceObject, pIRP
	mov ECX, pIRP
	sub EDX, EDX							; EDX = 0
	push EDX								; STATUS_SUCCESSFUL
	mov DWORD PTR [ECX + 1Ch], EDX				; IO_STATUS_BLOCK.Information
	mov DWORD PTR [ECX + 18h], EDX				; IO_STATUS_BLOCK.Status
	invoke IoCompleteRequest, ECX, EDX				; IO_NO_INCREMENT = 0
	pop EAX
	ret
StandardDispatch endp



;_________________________________________________________________________________________



DriverUnload proc DriverObject
	invoke IoDeleteSymbolicLink, ADDR SymbolicLinkNameUnicode
	mov EAX, DriverObject 
	invoke IoDeleteDevice, [EAX + 4]				; DRIVER_OBJECT.PDEVICE_OBJECT
	ret
DriverUnload endp



;_________________________________________________________________________________________



DriverDispatch proc USES EAX EBX ECX EDX ESI EDI DeviceObject, pIRP
	LOCAL CONTROL_CODE:DWORD
	mov ECX, pIRP
	ASSUME ECX:PTR _IRP
	ASSUME ESI:PTR _sDataStruct					; dStruct
	mov EDI, DWORD PTR[ECX + 60h]					; 96 = 60h pIRP.Tail.Overlay.CurrentStackLocation
	mov ESI, DWORD PTR[ECX + 0Ch] 				; 12 = 0Ch pIRP.AssociatedIrp.SystemBuffer
	mov AL, [ESI].c1							; SECTOR
	mov dStruct.c1, AL 
	mov AL, [ESI].c2							; CYLINDER HIGH
	mov dStruct.c2, AL 
	mov AL, [ESI].c3							; CYLINDER LOW
	mov dStruct.c3, AL
	mov AL, [ESI].c4							; DRIVE
	mov dStruct.c4, AL
	mov EAX, [EDI + 0Ch]						; Control Code for IoDeviceControl
	mov CONTROL_CODE, EAX						; save control code
	push ECX								; save IRP for IrpStack->MajorFunction
	cmp CONTROL_CODE, IOCTL_SPEAKER_ON				; IOCTL_SPEAKER_ON
	jne not_on 
	invoke Speaker_On, 5, 2						; call procedure frequency high low
	jmp Leave_Dispatch 
not_on:
	cmp CONTROL_CODE, IOCTL_SPEAKER_OFF
	jne not_off
	call Speaker_Off
	jmp Leave_Dispatch
not_off:
	cmp CONTROL_CODE, IOCTL_READ_HARD_DISK_SECTOR 
	jne not_read
	call Read_Hard_Disk_Sector
	jmp Leave_Dispatch
not_read:
	cmp CONTROL_CODE, IOCTL_READ_MEMORY
	jne not_memory
;	mov EAX, 0FE000h
;	mov memory_offset.low_part, EAX 
	call Read_Memory
	jmp Leave_Dispatch
not_memory:
	cmp CONTROL_CODE, IOCTL_FUNCTION_ADDRESS
	jne not_file
	call Call_Function_By_Address
	jmp Leave_Dispatch
not_file:
Leave_Dispatch: 
	pop ECX								; get IRP
	push EAX
	mov DWORD PTR [ECX + 1Ch], 520				; IO_STATUS_BLOCK.Information 
	mov DWORD PTR [ECX + 18h], ESI				; IO_STATUS_BLOCK.Status
	mov EDX, 0								; IO_NO_INCREMENT = 0
	invoke IoCompleteRequest, ECX, EDX
	pop EAX								; return with EAX = STATUS
	ret
DriverDispatch endp



;_________________________________________________________________________________________



Speaker_On proc		frequency_high:DWORD, frequency_low:DWORD
	LOCAL counter:DWORD
	in AL, 61h
	or AL, 3
	out 61h, AL
	mov AL, 0B6h
	out 43h, AL
	mov EAX, frequency_low						; 2
	out 42h, AL
	mov EAX, frequency_high						; 5
	out 42h, AL
	mov counter, 0
	.repeat								; fill buffer
	mov EBX, counter 
	mov AX, roak_msg_on[EBX]
	mov [ESI].b[EBX], AL
	mov [ESI].b[EBX + 1], AH
	add counter, 2 
	.until (counter == 256)
	mov [ESI].Status, 0						; STATUS_SUCCESS
	ret
Speaker_On endp 



;_________________________________________________________________________________________



Speaker_Off proc
	LOCAL counter:DWORD
	in AL, 61h
	mov AL, 61h
	and AL, 0FCh
	out 61h, AL
	mov counter, 0
	.repeat								; fill buffer
	mov EBX, counter 
	mov AX, roak_msg_off[EBX]
	mov [ESI].b[EBX], AL
	mov [ESI].b[EBX + 1], AH 
	add counter, 2
	.until (counter == 256)
	mov [ESI].Status, 0						; STATUS_SUCCESS
	ret 
Speaker_Off endp



;_________________________________________________________________________________________



Read_Hard_Disk_Sector proc
	LOCAL counter:DWORD
	mov DX, 1F2h							; sector count port 
	mov AL, 1								; read only one sector
	out DX, AL
	mov DX, 1F3h							; sector number port
	mov AL, dStruct.c1						; sector #					
	out DX, AL 
	mov DX, 1F4h							; cylinder low port
	mov AL, dStruct.c2						; cylinder low part			
	out DX, AL 
	mov DX, 1F5h							; cylinder high port
	mov AL, dStruct.c3						; cylinder high part			
	out DX, AL
	mov DX, 1F6h							; drive and head port
	mov AL, dStruct.c4						; drive/head
	; BIT	10100000b = 0A0h = 160 = MASTER HEAD 0
	; OR	00010000b = 0B0h = 176 = SLAVE HEAD 0
	; OR  00000000b to 00001111b or 0 to 15 heads
	out DX, AL
	mov DX, 1F7h							; command port
	mov AL, 20h								; read with retry
	out DX, AL 
still_going:								; Is read done? 
	in AL, DX
	test AL, 8								; This means the sector buffer requires servicing.
	jz still_going							; Don't continue until the sector buffer is ready.
	mov counter, 0 
	.repeat								; GET SECTOR BUFFER FROM DATA PORT 1F0h
	mov DX, 1F0h
	in AX, DX
	mov EBX, counter
	mov [ESI].b[EBX], AL
	mov dStruct.b[EBX], AL
	mov [ESI].b[EBX + 1], AH
	mov dStruct.b[EBX + 1], AH
	add counter, 2
	.until (counter == 512)
	invoke Write_Data_To_File, ADDR dStruct.b, 512, ADDR file_name, 1	; buffer written to file c:\roak.txt
	mov [ESI].Status, 0						; STATUS_SUCCESS
	ret
Read_Hard_Disk_Sector endp



;_________________________________________________________________________________________



Read_Memory proc
	LOCAL counter:DWORD
	LOCAL memory_length:DWORD
	LOCAL ZwOpenSection_handle:DWORD
	LOCAL memory_O_A_S:OBJECT_ATTRIBUTES_STRUCT
	invoke RtlInitUnicodeString, ADDR MySNDeviceNameUnicode, ADDR MySNDeviceName
	mov EAX, 24								; FILL O_A_S STRUCTURE
	mov memory_O_A_S.oasLength, EAX				; size of O_A_S
	mov EAX, 0
	mov memory_O_A_S.RootDirectory, EAX				; handle
	mov EAX, offset MySNDeviceNameUnicode			; never DWORD PTR
	mov memory_O_A_S.ObjectName, EAX				; unicode string structure
	mov EAX, OBJ_CASE_INSENSITIVE 
	mov memory_O_A_S.Attributes, EAX
	mov EAX, 0
	mov memory_O_A_S.SecurityDescriptor, EAX
	mov memory_O_A_S.SecurityQualityOfService, EAX
	invoke ZwOpenSection, ADDR ZwOpenSection_handle, 4, ADDR memory_O_A_S
	mov memory_length, 1						; for one page
	invoke ZwMapViewOfSection, ZwOpenSection_handle, -1, ADDR out_memory_virtual_address, 0, 1, ADDR memory_offset, ADDR memory_length, 1, 0, 2
	invoke Write_Data_To_File, out_memory_virtual_address, 4096, ADDR file_name, 1
	add out_memory_virtual_address, 0C71h			; start of byte serial number from offset
	mov EAX, [out_memory_virtual_address]
	ASSUME EDX:PTR _My_Serial_Number_Structure
	mov EDX, EAX
	mov counter, 0
	.repeat
		mov EBX, counter
		mov AX, [EDX].character[EBX]				; 37 characters
			.if EBX > 37
				mov AX, '~~'
			.endif
		mov [ESI].b[EBX], AL
		mov [ESI].b[EBX + 1], AH
		add counter, 2
	.until (counter == 256)
	mov [ESI].Status, STATUS_SUCCESS
	ret
Read_Memory endp



;_________________________________________________________________________________________



Call_Function_By_Address proc
	LOCAL pBase:PVOID
	LOCAL pre_initialized_base:DWORD
	LOCAL counter:DWORD
	LOCAL current_time:DWORD
	LOCAL future:DWORD
	LOCAL testor:DWORD
	mov pBase, 0
;*	invoke strcpy, ADDR a_dll_string, ADDR hal_string
;	invoke strcpy, ADDR a_dll_string, ADDR ntoskrnl_string
;	invoke strcpy, ADDR a_dll_string, ADDR bootvid_string
	invoke strcpy, ADDR a_dll_string, ADDR ntdll_string
;	invoke strcpy, ADDR a_dll_string, ADDR win32k_string
;*	invoke strcpy, ADDR a_dll_string_ext, ADDR hal_dll_string
;	invoke strcpy, ADDR a_dll_string_ext, ADDR ntoskrnl_exe_string
;	invoke strcpy, ADDR a_dll_string_ext, ADDR bootvid_dll_string
	invoke strcpy, ADDR a_dll_string_ext, ADDR ntdll_dll_string
;	invoke strcpy, ADDR a_dll_string_ext, ADDR win32k_sys_string
	call Get_Base
	.if (EAX == STATUS_NO_SUCH_FILE)
		jmp give_them_error_msg
	.endif	
	mov pBase, EAX
	mov pre_initialized_base, EAX					; save
	.if (pBase != 0)
	invoke ExFreePoolWithTag, pointer_to_module_list, 'KAOR'
	.endif
	invoke RtlImageNtHeader, pre_initialized_base
	mov pBase, EAX
	invoke Write_PIMAGE_NT_HEADER_To_File, pBase, pre_initialized_base
	.if (EAX == STATUS_DATA_ERROR)
		invoke memset, ADDR buffy, 0, 512
		invoke strcpy, ADDR buffy, ADDR err_module
		jmp give_them_error_msg
	.endif
	invoke Write_Table_Of_Functions_To_File, pre_initialized_base,  EAX, iedNumberOfFunctions	; EAX = inh_OptionalHeader_DataDirectory_VirtualAddress from Write_PIMAGE_NT_HEADER_To_File
						; HAL.DLL.....
	.if(hmb_function_address != 0)
		mov EAX, 2600						; frequency
		push EAX
		call DWORD PTR [hmb_function_address]		; call hal.dll's HalMakeBeep
	.endif
						; NTDLL.DLL....
	mov testor, 0
	invoke HalMakeBeep, 2600					; frequency
wait_loop:
	.if(gtc_function_address != 0)
		call DWORD PTR [gtc_function_address]		; call ntdll's ZwGetTickCount
		mov current_time, EAX
	.endif
	.if (testor == 0)
		add current_time, 3000					; 3 second delay
		mov EAX, current_time
		mov future, EAX
	.endif
	mov testor, 1
	mov ECX, future
	.if(current_time <= ECX && gtc_function_address != 0)
		jmp wait_loop
	.endif
	invoke HalMakeBeep, 0
	mov EAX, 0
	mov EDX, EAX
give_them_error_msg:
	mov counter, 0
	.repeat
	mov EBX, counter
	mov AL, buffy[EBX]
	mov [ESI].b[EBX], AL
	add counter, 1
	.until (counter == 512)
	mov [ESI].Status, EDX
	ret
Call_Function_By_Address endp



;________________________________________________________________________________________



Write_Data_To_File proc		address_of_data_to_write:DWORD, data_size:DWORD, address_of_file_name:DWORD, read_write_test:DWORD
	invoke RtlInitUnicodeString, ADDR FileNameUnicode, address_of_file_name
	mov EAX, 24
	mov file_O_A_S.oasLength, EAX					; size of O_A_S
	mov EAX, 0
	mov file_O_A_S.RootDirectory, EAX				; handle
	mov EAX, offset FileNameUnicode
	mov file_O_A_S.ObjectName, EAX				; unicode string structure
	mov EAX, OBJ_CASE_INSENSITIVE
	mov file_O_A_S.Attributes, EAX
	mov EAX, 0
	mov file_O_A_S.SecurityDescriptor, EAX
	mov file_O_A_S.SecurityQualityOfService, EAX
	.if read_write_test == 0					; open existing
		invoke ZwCreateFile, ADDR hFile, FILE_APPEND_DATA, ADDR file_O_A_S, ADDR iostatus, 0, 0, FILE_APPEND_DATA or FILE_WRITE_TO_END_OF_FILE, FILE_OPEN_IF, FILE_SYNCHRONOUS_IO_NONALERT, 0, 0
	.endif
	.if read_write_test == 1					; create new
		invoke ZwCreateFile, ADDR hFile, GENERIC_WRITE, ADDR file_O_A_S, ADDR iostatus, 0, FILE_ATTRIBUTE_NORMAL, 0, FILE_OVERWRITE_IF, FILE_SYNCHRONOUS_IO_NONALERT, 0, 0
	.endif
	invoke ZwWriteFile, hFile, 0, 0, 0, ADDR iostatus, address_of_data_to_write, data_size, 0, 0
	invoke ZwClose, hFile
	ret
Write_Data_To_File endp



;________________________________________________________________________________________



Get_Pointer_To_Module_List proc				; RETURNS POINTER TO MODULE LIST
	LOCAL my_status:DWORD
	LOCAL data_size:DWORD
	LOCAL bytes_returned:DWORD
	mov my_status, STATUS_INVALID_PARAMETER
	mov data_size, 4096
start_of_module_loop:
	.if data_size < 1
		mov data_size, 1
	.endif
	invoke ExAllocatePoolWithTag, PagedPool, data_size, 'KAOR'
	mov pointer_to_module_list, EAX
	.if pointer_to_module_list == 0
		mov my_status, STATUS_NO_MEMORY
		jmp no_memory
	.endif
	invoke ZwQuerySystemInformation, SystemModuleInfo, pointer_to_module_list, data_size, ADDR bytes_returned
	mov my_status, EAX
	.if my_status == 0
		jmp successful
	.endif
		.if my_status != STATUS_SUCCESS
			.if bytes_returned != 0
				invoke ExFreePoolWithTag, pointer_to_module_list, 'KAOR'
				mov pointer_to_module_list, 0
				mov bytes_returned, 0
					.if my_status != STATUS_INFO_LENGTH_MISMATCH
						jmp mrs_match
					.endif
			.endif
		.endif
no_memory:
mrs_match:
		mov EAX, data_size
		shl EAX, 1
		mov data_size, EAX
		.if pointer_to_module_list == 0 && data_size != 1
			jmp start_of_module_loop
		.endif
successful:
	mov EAX, pointer_to_module_list
	ret
Get_Pointer_To_Module_List endp



;________________________________________________________________________________________



Get_Base proc
	LOCAL counter:DWORD
	LOCAL dIndex:DWORD
	LOCAL test_ext:DWORD
	LOCAL dBase:DWORD
	LOCAL maximum_number_of_modules:DWORD
	mov dIndex, -1
	invoke sprintf, ADDR buffy, ADDR module_table_title, 0 
	invoke Write_Data_To_File, ADDR buffy, sizeof module_table_title, ADDR file_name, 1
	ASSUME EAX:PMODULE_LIST
	call Get_Pointer_To_Module_List
	mov pointer_to_module_list, EAX				; save pointer
	mov ECX, [EAX].count_Modules
	mov maximum_number_of_modules, ECX
	mov counter, 0
look_at_module_loop:
	mov EAX, pointer_to_module_list				; restore pointer
	push ESI
	push EDI
	mov EBX, counter
	lea ESI, buffy
	lea EDI, DWORD PTR [EAX].actual_Modules.byte_array_ImageName
	movzx EDX, [EAX].actual_Modules.word_NameOffset
	add EDI, EDX							; first offset
	imul EAX, counter, sizeof(_SYSTEM_MODULE_INFORMATION)	; 284 bytes
	add EDI, EAX
copy_string_loop:
	mov AL, BYTE PTR [EDI] 
	mov BYTE PTR [ESI], AL 
	inc EDI
	inc ESI 
	or AL, AL
	jnz copy_string_loop
	pop EDI
	pop ESI
	call Clean_String
	invoke _stricmp, ADDR buffy, ADDR a_dll_string		; find *.dll
	mov EBX, EAX
	.if (EAX == 0)
		mov test_ext, 0
	.endif
	invoke _stricmp, ADDR buffy, ADDR a_dll_string_ext	; find *.dll with extension
	.if (EAX == 0)
		mov test_ext, 1
	.endif
	.if (EAX == 0 || EBX == 0)
		mov EAX, counter
		mov dIndex, EAX
	.endif
	.if(buffy[0] != 0)
	invoke Write_Data_To_File, ADDR buffy, 15, ADDR file_name, 0
	.else
	invoke memset, ADDR buffy, 0, 25
	invoke sprintf, ADDR buffy, ADDR nothing_there, counter 
	invoke Write_Data_To_File, ADDR buffy, 15, ADDR file_name, 0
	.endif
	invoke Write_Data_To_File, ADDR new_line, sizeof new_line, ADDR file_name, 0
	inc counter
	mov ECX, maximum_number_of_modules
	.if counter < ECX	
		jmp look_at_module_loop
	.endif
	.if (dIndex == -1)
		invoke strcpy, ADDR buffy, ADDR err_module
		mov EAX, STATUS_NO_SUCH_FILE
		ret
	.endif
	.if (dIndex != -1)
		mov EAX, pointer_to_module_list			; restore pointer
		push EDI							; get your module
		lea EDI, DWORD PTR [EAX].actual_Modules.Base
		mov EAX, dIndex
		mov ECX, 284
		mul ECX
		add EDI, EAX
		mov EBX, DWORD PTR [EDI]
		pop EDI
		mov dBase, EBX
	.endif
	invoke memset, ADDR buffy, 0, 512
	.if (test_ext == 0)
	invoke sprintf, ADDR buffy, ADDR output_string, ADDR a_dll_string, dIndex, dBase
	.endif
	.if (test_ext == 1)
	invoke sprintf, ADDR buffy, ADDR output_string, ADDR a_dll_string_ext, dIndex, dBase
	.endif
	mov EAX, dBase
	mov function_address_base, EAX
	ret
Get_Base endp



;________________________________________________________________________________________



Clean_String proc
	LOCAL counter:DWORD
	LOCAL last_slash:DWORD
	LOCAL maximum:DWORD
	LOCAL local_byte_array[512]:BYTE
	invoke strlen, ADDR buffy
	mov counter, EAX
clean_the_string:
	mov EBX, counter
	mov AL, buffy[EBX]
	cmp AL, 92							; '\'
	je clean_break
	dec counter
	.if (counter == 0)
		jmp pre_null_loop					; no slash skip to zero out rest of buffer
	.endif
	jmp clean_the_string
clean_break:
	mov EAX, counter
	add EAX, 1
	mov last_slash, EAX
	mov maximum, EAX
	mov counter, 0
stuff_loop:
	mov EBX, last_slash
	mov AL, buffy[EBX]
	mov EBX, counter
	mov local_byte_array[EBX], AL
	inc last_slash
	inc counter
	mov EAX, maximum
	.if (counter < EAX)
	jmp stuff_loop
	.endif
	invoke strcpy, ADDR buffy, ADDR local_byte_array
pre_null_loop:
	invoke strlen, ADDR buffy
	mov counter, EAX
null_loop:
	mov EBX, counter
	mov buffy[EBX + 1], 0
	inc EBX
	inc counter
	.if (counter < 30)
		jmp null_loop
	.endif
	invoke strlen, ADDR buffy
	mov counter, 0
is_not_char:
	mov EBX, counter
	mov AL, buffy[EBX]
	.if ((AL < 97 || AL > 122) && (AL < 65 || AL > 90) && AL != 46 && (AL < 48 || AL > 57))
		mov AL, 0
		mov buffy[EBX], AL
	.endif
	inc counter
	.if (counter < 28)
		jmp is_not_char
	.endif
	ret
Clean_String endp



;________________________________________________________________________________________



Write_PIMAGE_EXPORT_DIRECTORY_To_File proc	pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD
	LOCAL iedMajorVersion:DWORD
	LOCAL iedMinorVersion:DWORD
	mov EAX, pre_initialized_base					; PTR_ADD
	add EAX, inh_OptionalHeader_DataDirectory_VirtualAddress
	ASSUME EAX:PIMAGE_EXPORT_DIRECTORY				; PIMAGE_EXPORT_DIRECTORY
	movzx EBX, [EAX].MajorVersion					; WORD VALUE OF MAJOR VERSION
	mov iedMajorVersion, EBX
	movzx EBX, [EAX].MinorVersion					; WORD VALUE OF MINOR VERSION
	mov iedMinorVersion, EBX
	mov EBX, [EAX].iedName						; NAME OF DLL
	add EBX, pre_initialized_base
	mov iedName, EBX
	mov EBX, [EAX].NumberOfFunctions				; NUMBER OF FUNCTIONS
	mov iedNumberOfFunctions, EBX
	push EAX
	mov EAX, [EAX].TimeDateStamp
	push EAX
	call Time_Date_Stamp@4
	mov EBX, EAX
	pop EAX
	invoke sprintf, ADDR ied_buffy, ADDR ied_string, iedName, [EAX].Characteristics, [EAX].TimeDateStamp, EBX, iedMajorVersion, iedMinorVersion, iedName, [EAX].Base, iedNumberOfFunctions, [EAX].NumberOfNames, [EAX].AddressOfFunctions, [EAX].AddressOfNames, [EAX].AddressOfNameOrdinals
	ASSUME EAX:NOTHING
	invoke Write_Data_To_File, ADDR ied_buffy, 1024, ADDR file_name, 0
	mov EAX, iedNumberOfFunctions
	ret
Write_PIMAGE_EXPORT_DIRECTORY_To_File endp



;________________________________________________________________________________________



Write_PIMAGE_NT_HEADER_To_File proc pBase:DWORD, pre_initialized_base:DWORD
	LOCAL inh_Signature:DWORD
	LOCAL inh_FileHeader_Machine:DWORD
	LOCAL inh_FileHeader_NumberOfSections:DWORD
	LOCAL inh_FileHeader_TimeDateStamp:DWORD
	LOCAL inh_FileHeader_PointerToSymbolTable:DWORD
	LOCAL inh_FileHeader_NumberOfSymbols:DWORD
	LOCAL inh_FileHeader_SizeOfOptionHeader:DWORD
	LOCAL inh_FileHeader_Characteristics:DWORD
	LOCAL inh_OptionalHeader_Magic:DWORD
	LOCAL inh_OptionalHeader_MajorLinkerVersion
	LOCAL inh_OptionalHeader_MinorLinkerVersion
	LOCAL inh_OptionalHeader_SizeOfCode:DWORD
	LOCAL inh_OptionalHeader_SizeOfInitializedData:DWORD
	LOCAL inh_OptionalHeader_SizeOfUninitializedData:DWORD
	LOCAL inh_OptionalHeader_AddressOfEntryPoint:DWORD
	LOCAL inh_OptionalHeader_BaseOfCode:DWORD
	LOCAL inh_OptionalHeader_BaseOfData:DWORD
	LOCAL inh_OptionalHeader_ImageBase:DWORD
	LOCAL inh_OptionalHeader_SectionalAlignment:DWORD
	LOCAL inh_OptionalHeader_FileAlignment:DWORD
	LOCAL inh_OptionalHeader_MajorOperatingSystemVersion:DWORD
	LOCAL inh_OptionalHeader_MinorOperatingSystemVersion:DWORD
	LOCAL inh_OptionalHeader_MajorImageVersion:DWORD
	LOCAL inh_OptionalHeader_MinorImageVersion:DWORD
	LOCAL inh_OptionalHeader_MajorSubsystemVersion:DWORD
	LOCAL inh_OptionalHeader_MinorSubsystemVersion:DWORD
	LOCAL inh_OptionalHeader_Win32VersionValue:DWORD
	LOCAL inh_OptionalHeader_SizeOfImage:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeaders:DWORD
	LOCAL inh_OptionalHeader_CheckSum:DWORD
	LOCAL inh_OptionalHeader_Subsystem:DWORD
	LOCAL inh_OptionalHeader_DllCharacteristics:DWORD
	LOCAL inh_OptionalHeader_SizeOfStackReserve:DWORD
	LOCAL inh_OptionalHeader_SizeOfStackCommit:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeapReserve:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeapCommit:DWORD
	LOCAL inh_OptionalHeader_LoaderFlags:DWORD
	LOCAL inh_OptionalHeader_NumberOfRvaAndSizes:DWORD
	LOCAL inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD
	LOCAL inh_OptionalHeader_DataDirectory_Size:DWORD
	.if (pBase != 0)
	mov EDX, pBase
	ASSUME EDX:PIMAGE_NT_HEADER
		.if ([EDX].OptionalHeader.DataDirectory.VirtualAddress && ([EDX].OptionalHeader.DataDirectory.iddSize >= 40))	; sizeof _IMAGE_EXPORT_DIRECTORY = 40
			mov EBX, [EDX].Signature
			mov inh_Signature, EBX
			movzx EBX, [EDX].FileHeader.Machine					; WORD
			mov inh_FileHeader_Machine, EBX
			movzx EBX, [EDX].FileHeader.NumberOfSections			; WORD
			mov inh_FileHeader_NumberOfSections, EBX
			mov EBX, [EDX].FileHeader.TimeDateStamp
			mov inh_FileHeader_TimeDateStamp, EBX
			mov EBX, [EDX].FileHeader.PointerToSymbolTable
			mov inh_FileHeader_PointerToSymbolTable, EBX
			mov EBX, [EDX].FileHeader.NumberOfSymbols
			mov inh_FileHeader_NumberOfSymbols, EBX
			movzx EBX, [EDX].FileHeader.SizeOfOptionHeader			; WORD
			mov inh_FileHeader_SizeOfOptionHeader, EBX
			movzx EBX, [EDX].FileHeader.Characteristics			; WORD
			mov inh_FileHeader_Characteristics, EBX
			movzx EBX, [EDX].OptionalHeader.Magic				; WORD
			mov inh_OptionalHeader_Magic, EBX
			movzx EBX, [EDX].OptionalHeader.MajorLinkerVersion		; BYTE
			mov inh_OptionalHeader_MajorLinkerVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorLinkerVersion		; BYTE
			mov inh_OptionalHeader_MinorLinkerVersion, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfCode
			mov inh_OptionalHeader_SizeOfCode, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfInitializedData
			mov inh_OptionalHeader_SizeOfInitializedData, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfUninitializedData
			mov inh_OptionalHeader_SizeOfUninitializedData, EBX
			mov EBX, [EDX].OptionalHeader.AddressOfEntryPoint
			mov inh_OptionalHeader_AddressOfEntryPoint, EBX
			mov EBX, [EDX].OptionalHeader.BaseOfCode
			mov inh_OptionalHeader_BaseOfCode, EBX
			mov EBX, [EDX].OptionalHeader.BaseOfData
			mov inh_OptionalHeader_BaseOfData, EBX
			mov EBX, [EDX].OptionalHeader.ImageBase
			mov inh_OptionalHeader_ImageBase, EBX
			mov EBX, [EDX].OptionalHeader.SectionalAlignment
			mov inh_OptionalHeader_SectionalAlignment, EBX
			mov EBX, [EDX].OptionalHeader.FileAlignment
			mov inh_OptionalHeader_FileAlignment, EBX
			movzx EBX, [EDX].OptionalHeader.MajorOperatingSystemVersion	; WORD
			mov inh_OptionalHeader_MajorOperatingSystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorOperatingSystemVersion	; WORD
			mov inh_OptionalHeader_MinorOperatingSystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MajorImageVersion		; WORD
			mov inh_OptionalHeader_MajorImageVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorImageVersion		; WORD
			mov inh_OptionalHeader_MinorImageVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MajorSubsystemVersion		; WORD
			mov inh_OptionalHeader_MajorSubsystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorSubsystemVersion		; WORD
			mov inh_OptionalHeader_MinorSubsystemVersion, EBX
			mov EBX, [EDX].OptionalHeader.Win32VersionValue
			mov inh_OptionalHeader_Win32VersionValue, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfImage
			mov inh_OptionalHeader_SizeOfImage, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeaders
			mov inh_OptionalHeader_SizeOfHeaders, EBX
			mov EBX, [EDX].OptionalHeader.CheckSum
			mov inh_OptionalHeader_CheckSum, EBX
			movzx EBX, [EDX].OptionalHeader.Subsystem				; WORD
			mov inh_OptionalHeader_Subsystem, EBX
			movzx EBX, [EDX].OptionalHeader.DllCharacteristics		; WORD
			mov inh_OptionalHeader_DllCharacteristics, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfStackReserve
			mov inh_OptionalHeader_SizeOfStackReserve, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfStackCommit
			mov inh_OptionalHeader_SizeOfStackCommit, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeapReserve
			mov inh_OptionalHeader_SizeOfHeapReserve, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeapCommit
			mov inh_OptionalHeader_SizeOfHeapCommit, EBX
			mov EBX, [EDX].OptionalHeader.LoaderFlags
			mov inh_OptionalHeader_LoaderFlags, EBX
			mov EBX, [EDX].OptionalHeader.NumberOfRvaAndSizes
			mov inh_OptionalHeader_NumberOfRvaAndSizes, EBX
			mov EBX, [EDX].OptionalHeader.DataDirectory.VirtualAddress	; NEEDED FOR OTHER PROCEDURES
			mov inh_OptionalHeader_DataDirectory_VirtualAddress, EBX
			mov EBX, [EDX].OptionalHeader.DataDirectory.iddSize
			mov inh_OptionalHeader_DataDirectory_Size, EBX
		.else
			mov EAX, STATUS_DATA_ERROR
			ret
		.endif
		push EDX								; to get iedName
		invoke Write_PIMAGE_EXPORT_DIRECTORY_To_File, pre_initialized_base, inh_OptionalHeader_DataDirectory_VirtualAddress
		mov EAX, inh_FileHeader_TimeDateStamp
		push EAX
		call Time_Date_Stamp@4
		mov EBX, EAX
		pop EDX
		invoke sprintf, ADDR inh_buffy_1, ADDR inh_string_1, iedName, inh_Signature, inh_FileHeader_Machine, inh_FileHeader_NumberOfSections, inh_FileHeader_TimeDateStamp, EBX, inh_FileHeader_PointerToSymbolTable, inh_FileHeader_NumberOfSymbols, inh_FileHeader_SizeOfOptionHeader
		invoke sprintf, ADDR inh_buffy_2, ADDR inh_string_2, inh_FileHeader_Characteristics, inh_OptionalHeader_Magic, inh_OptionalHeader_MajorLinkerVersion, inh_OptionalHeader_MinorLinkerVersion, inh_OptionalHeader_SizeOfCode, inh_OptionalHeader_SizeOfInitializedData, inh_OptionalHeader_SizeOfUninitializedData, inh_OptionalHeader_AddressOfEntryPoint, inh_OptionalHeader_BaseOfCode
		invoke sprintf, ADDR inh_buffy_3, ADDR inh_string_3, inh_OptionalHeader_BaseOfData, inh_OptionalHeader_ImageBase, inh_OptionalHeader_SectionalAlignment, inh_OptionalHeader_FileAlignment, inh_OptionalHeader_MajorOperatingSystemVersion, inh_OptionalHeader_MinorOperatingSystemVersion, inh_OptionalHeader_MajorImageVersion, inh_OptionalHeader_MinorImageVersion, inh_OptionalHeader_MajorSubsystemVersion
		invoke sprintf, ADDR inh_buffy_4, ADDR inh_string_4, inh_OptionalHeader_MinorSubsystemVersion, inh_OptionalHeader_Win32VersionValue, inh_OptionalHeader_SizeOfImage, inh_OptionalHeader_SizeOfHeaders, inh_OptionalHeader_CheckSum, inh_OptionalHeader_Subsystem, inh_OptionalHeader_DllCharacteristics
		invoke sprintf, ADDR inh_buffy_5, ADDR inh_string_5, inh_OptionalHeader_SizeOfStackReserve, inh_OptionalHeader_SizeOfStackCommit, inh_OptionalHeader_SizeOfHeapReserve, inh_OptionalHeader_SizeOfHeapCommit, inh_OptionalHeader_LoaderFlags, inh_OptionalHeader_NumberOfRvaAndSizes, inh_OptionalHeader_DataDirectory_VirtualAddress, inh_OptionalHeader_DataDirectory_Size
		ASSUME EDX:NOTHING
		invoke Write_Data_To_File, ADDR inh_buffy_1, 1024, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_buffy_2, 1024, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_buffy_3, 1024, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_buffy_4, 1024, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_buffy_5, 1024, ADDR file_name, 0
	.endif
	mov EAX, inh_OptionalHeader_DataDirectory_VirtualAddress
	ret
Write_PIMAGE_NT_HEADER_To_File endp



;________________________________________________________________________________________



Write_Table_Of_Functions_To_File proc USES ESI EDI EBX ECX EDX	pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD, NumberOfFunctions:DWORD
	LOCAL counter:DWORD
	invoke sprintf, ADDR function_buffy, ADDR function_table_name, iedName
	invoke Write_Data_To_File, ADDR function_buffy, 70, ADDR file_name, 0
	ASSUME EDX:PIMAGE_EXPORT_DIRECTORY
	mov EDX, pre_initialized_base
	add EDX, inh_OptionalHeader_DataDirectory_VirtualAddress
	mov ESI, [EDX].AddressOfNames
	add ESI, pre_initialized_base
	mov EAX, [EDX].AddressOfNameOrdinals
	add EAX, pre_initialized_base
	mov EBX, EAX
	mov EAX, [EDX].AddressOfFunctions
	add EAX, pre_initialized_base
	mov EDI, EAX
	mov counter, 0
	.repeat
		mov EAX, DWORD PTR [ESI]				; name array
		add EAX, pre_initialized_base
		mov RVA_NAME, EAX	
		mov EDX, [EBX]
		movzx EDX, DX						; word ordinals
		mov ECX, EDX
		add ECX, 1							; counter
		shl EDX, 2							; * 4 bytes along pointer
		add EDX, EDI
		push EBX							; GET FUNCTION ADDRESSES
		push ECX
		push EDX
		mov EBX, ECX						; counter
		mov EAX, function_address_base			; get function address by adding module address
		add EAX, DWORD PTR [EDX]				; with base address from Get_Base procedure
		mov address_plus_base, EAX
		invoke _stricmp, ADDR hal_make_beep, RVA_NAME
		.if (EAX == 0)
		mov EAX, address_plus_base
		mov hmb_function_address, EAX
		.endif
		invoke _stricmp, ADDR ntdll_zw_get_tick_count, RVA_NAME
		.if (EAX == 0)
		mov EAX, address_plus_base
		mov gtc_function_address, EAX
		.endif
		pop EDX
		pop ECX
		pop EBX
		invoke sprintf, ADDR function_buffy, ADDR function_string, RVA_NAME, ECX, DWORD PTR [EDX], address_plus_base
		invoke Write_Data_To_File, ADDR new_line, 2, ADDR file_name, 0
		invoke Write_Data_To_File, addr function_buffy, 70, ADDR file_name, 0
		add ESI, 4
		add EBX, 2
		inc counter
		mov ECX, iedNumberOfFunctions
	.until (counter == ECX)
	ASSUME EDX:NOTHING
	ret
Write_Table_Of_Functions_To_File endp



;________________________________________________________________________________________



END










;;;;;;;;;;;;;;












;
;;;;;;;;;;;;;

;
;;;;;;;;;;;;;;;;



